//
// Model.cpp
//
#include "stdafx.h"

#include "Model.h"

#include "OpenGLExtFuncs.h"

void CGroup::MakeVBO()
{
	// VBO ID z̐
	if( 0 == m_auiVboID[0] )
	{
		glGenBuffers( 3, m_auiVboID );
	}

	if( 0 == m_vuiIndexIndexedTriangle.size() )
	{
		return;
	}

	// Op`_z
	unsigned int uiCountData = m_vuiIndexIndexedTriangle.size() * 3 * 3;	// P̎Op`́AR_BP_͂RWlB
	float* afTriangleVertex = new float[uiCountData];
	for( unsigned int uiIndexTriangle = 0; uiIndexTriangle < m_vuiIndexIndexedTriangle.size(); uiIndexTriangle++ )
	{
		// _ԍێOp`̔ԍ̎擾
		unsigned int uiIndexIndexedTriangle = m_vuiIndexIndexedTriangle[uiIndexTriangle];
		// _ԍێOp`̎擾
		CIndexedTriangle& rIndexedTriangle = m_pModel->m_vIndexedTriangle[uiIndexIndexedTriangle];
		for( unsigned int ui3 = 0; ui3 < 3; ui3++ )
		{
			// _ԍ璸_f[^̎擾
			CVector& rVertex = m_pModel->m_vVertex[rIndexedTriangle.m_ui3IndexVertex[ui3]];
			afTriangleVertex[uiIndexTriangle * 9 + ui3 * 3 + 0] = rVertex.x;
			afTriangleVertex[uiIndexTriangle * 9 + ui3 * 3 + 1] = rVertex.y;
			afTriangleVertex[uiIndexTriangle * 9 + ui3 * 3 + 2] = rVertex.z;
		}
	}
	glBindBuffer( GL_ARRAY_BUFFER, GetTriangleVertexVboID() );
	glBufferData( GL_ARRAY_BUFFER, uiCountData * sizeof( float ), afTriangleVertex, GL_STATIC_DRAW );
	glBindBuffer( GL_ARRAY_BUFFER, 0 );	// oCh̉
	delete afTriangleVertex;	// VRAMɓ]f[^glBufferDataɂāAVRAMɃf[^uBRAMɃf[^͕svB

	// Ő_ԍz
	uiCountData = m_vuiIndexIndexedTriangle.size() * 3 * 2;	// ̎Op`́AR̗ŐBP̗Ő́AQ̒_B
	unsigned int* auiEdgeVertexIndex = new unsigned int[uiCountData];
	for( unsigned int uiIndexTriangle = 0; uiIndexTriangle < m_vuiIndexIndexedTriangle.size(); uiIndexTriangle++ )
	{
		auiEdgeVertexIndex[uiIndexTriangle * 6 + 0] = uiIndexTriangle * 3 + 0;
		auiEdgeVertexIndex[uiIndexTriangle * 6 + 1] = uiIndexTriangle * 3 + 1;
		auiEdgeVertexIndex[uiIndexTriangle * 6 + 2] = uiIndexTriangle * 3 + 1;
		auiEdgeVertexIndex[uiIndexTriangle * 6 + 3] = uiIndexTriangle * 3 + 2;
		auiEdgeVertexIndex[uiIndexTriangle * 6 + 4] = uiIndexTriangle * 3 + 2;
		auiEdgeVertexIndex[uiIndexTriangle * 6 + 5] = uiIndexTriangle * 3 + 0;
	}
	glBindBuffer( GL_ELEMENT_ARRAY_BUFFER, GetEdgeVertexIndexVboID() );
	glBufferData( GL_ELEMENT_ARRAY_BUFFER, uiCountData * sizeof( unsigned int ), auiEdgeVertexIndex, GL_STATIC_DRAW );
	glBindBuffer( GL_ELEMENT_ARRAY_BUFFER, 0 );	// oCh̉
	delete auiEdgeVertexIndex;	// VRAMɓ]f[^glBufferDataɂāAVRAMɃf[^uBRAMɃf[^͕svB

	// Op`_@z
	uiCountData = m_vuiIndexIndexedTriangle.size() * 3 * 3;	// 	// P̎Op`́AR_BP_͂RxNglB
	float* afTriangleVertexNormal = new float[uiCountData];
	for( unsigned int uiIndexTriangle = 0; uiIndexTriangle < m_vuiIndexIndexedTriangle.size(); uiIndexTriangle++ )
	{
		// _ԍێOp`̔ԍ̎擾
		unsigned int uiIndexIndexedTriangle = m_vuiIndexIndexedTriangle[uiIndexTriangle];
		// _ԍێOp`̎擾
		CIndexedTriangle& rIndexedTriangle = m_pModel->m_vIndexedTriangle[uiIndexIndexedTriangle];
		// _@ʖ@
		if( -1 != rIndexedTriangle.m_ui3IndexVertexNormal[0]
			&& -1 != rIndexedTriangle.m_ui3IndexVertexNormal[1]
			&& -1 != rIndexedTriangle.m_ui3IndexVertexNormal[2] )
		{	// _@
			// Op`̂R_xNg̎擾
			CVector& rVector0 = m_pModel->m_vVectorVertexNormal[rIndexedTriangle.m_ui3IndexVertexNormal[0]];
			CVector& rVector1 = m_pModel->m_vVectorVertexNormal[rIndexedTriangle.m_ui3IndexVertexNormal[1]];
			CVector& rVector2 = m_pModel->m_vVectorVertexNormal[rIndexedTriangle.m_ui3IndexVertexNormal[2]];
			// @xNglzɃZbg
			afTriangleVertexNormal[uiIndexTriangle * 9 + 0] = rVector0.x;
			afTriangleVertexNormal[uiIndexTriangle * 9 + 1] = rVector0.y;
			afTriangleVertexNormal[uiIndexTriangle * 9 + 2] = rVector0.z;
			afTriangleVertexNormal[uiIndexTriangle * 9 + 3] = rVector1.x;
			afTriangleVertexNormal[uiIndexTriangle * 9 + 4] = rVector1.y;
			afTriangleVertexNormal[uiIndexTriangle * 9 + 5] = rVector1.z;
			afTriangleVertexNormal[uiIndexTriangle * 9 + 6] = rVector2.x;
			afTriangleVertexNormal[uiIndexTriangle * 9 + 7] = rVector2.y;
			afTriangleVertexNormal[uiIndexTriangle * 9 + 8] = rVector2.z;
		}
		else
		{	// ʖ@
			// Op`̂R_W̎擾
			CVector& rVertex0 = m_pModel->m_vVertex[rIndexedTriangle.m_ui3IndexVertex[0]];
			CVector& rVertex1 = m_pModel->m_vVertex[rIndexedTriangle.m_ui3IndexVertex[1]];
			CVector& rVertex2 = m_pModel->m_vVertex[rIndexedTriangle.m_ui3IndexVertex[2]];
			// P_ڂQ_ڂւ̃xNgAQ_ڂR_ڂւ̃xNg߂
			CVector vector01( rVertex1.x - rVertex0.x,
				rVertex1.y - rVertex0.y,
				rVertex1.z - rVertex0.z );
			CVector vector12( rVertex2.x - rVertex1.x,
				rVertex2.y - rVertex1.y,
				rVertex2.z - rVertex1.z );
			// Q̃xNg̖@xNg߂
			CVector vectorNormal = { vector01.y * vector12.z - vector01.z * vector12.y,
								vector01.z * vector12.x - vector01.x * vector12.z,
								vector01.x * vector12.y - vector01.y * vector12.x };
			float fLength = (float)sqrt( vectorNormal.x * vectorNormal.x + vectorNormal.y * vectorNormal.y + vectorNormal.z * vectorNormal.z );
			vectorNormal.x /= fLength;
			vectorNormal.y /= fLength;
			vectorNormal.z /= fLength;
			// @xNglzɃZbg
			afTriangleVertexNormal[uiIndexTriangle * 9 + 0] = vectorNormal.x;
			afTriangleVertexNormal[uiIndexTriangle * 9 + 1] = vectorNormal.y;
			afTriangleVertexNormal[uiIndexTriangle * 9 + 2] = vectorNormal.z;
			afTriangleVertexNormal[uiIndexTriangle * 9 + 3] = vectorNormal.x;
			afTriangleVertexNormal[uiIndexTriangle * 9 + 4] = vectorNormal.y;
			afTriangleVertexNormal[uiIndexTriangle * 9 + 5] = vectorNormal.z;
			afTriangleVertexNormal[uiIndexTriangle * 9 + 6] = vectorNormal.x;
			afTriangleVertexNormal[uiIndexTriangle * 9 + 7] = vectorNormal.y;
			afTriangleVertexNormal[uiIndexTriangle * 9 + 8] = vectorNormal.z;
		}
	}
	glBindBuffer( GL_ARRAY_BUFFER, GetTriangleVertexNormalVboID() );
	glBufferData( GL_ARRAY_BUFFER, uiCountData * sizeof( float ), afTriangleVertexNormal, GL_STATIC_DRAW );
	glBindBuffer( GL_ARRAY_BUFFER, 0 );	// oCh̉
	delete afTriangleVertexNormal;	// VRAMɓ]f[^glBufferDataɂāAVRAMɃf[^uBRAMɃf[^͕svB
}

void CGroup::DestroyVBO()
{
	if( 0 == m_auiVboID[0] )
	{
		return;
	}

	glDeleteBuffers( 3, m_auiVboID );
	memset( m_auiVboID, 0x00, 3 * sizeof( unsigned int ) );
}

void CModel::Clear()
{
	m_vVertex.clear();
	m_vVectorVertexNormal.clear();
	m_vIndexedTriangle.clear();
	for( unsigned int ui = 0; ui < m_vpGroup.size(); ui++ )
	{
		CGroup* pGroup = m_vpGroup[ui];
		delete pGroup;
	}
	m_vpGroup.clear();
}

const CModel& CModel::operator = ( const CModel& model )
{
	// o[̃NA
	Clear();
	// o[̃Rs[
	m_vVertex = model.m_vVertex;
	m_vVectorVertexNormal = model.m_vVectorVertexNormal;
	m_vIndexedTriangle = model.m_vIndexedTriangle;
	m_vpGroup.assign( model.m_vpGroup.size(), NULL );
	for( unsigned int ui = 0; ui < m_vpGroup.size(); ui++ )
	{
		m_vpGroup[ui] = new CGroup( *model.m_vpGroup[ui] );	// O[ṽRs[
		m_vpGroup[ui]->m_pModel = this;	// Rs[ModelwĂ̂ARs[Modelw悤ɕύXB
	}
	return *this;
}

void CModel::MakeVBO()
{
	for( unsigned int uiIndexGroup = 0; uiIndexGroup < m_vpGroup.size(); uiIndexGroup++ )
	{
		m_vpGroup[uiIndexGroup]->MakeVBO();
	}
}

void CModel::DestroyVBO()
{
	for( unsigned int uiIndexGroup = 0; uiIndexGroup < m_vpGroup.size(); uiIndexGroup++ )
	{
		m_vpGroup[uiIndexGroup]->DestroyVBO();
	}
}
